'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = composeWithInnerType;

var _main = require('./main');

var _main2 = _interopRequireDefault(_main);

var _staticLand = require('static-land');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function composeWithInnerType(I) {

  var sequenceIS = I.sequence(_main2.default);
  var joinI = I.chain(function (x) {
    return x;
  });

  var Composed = (0, _staticLand.fromIncomplete)({
    of: function of(x) {
      return _main2.default.of(I.of(x));
    },
    map: function map(fn, composed) {
      return _main2.default.map(I.map(fn), composed);
    },
    ap: function ap(composedf, composedx) {
      return _main2.default.ap(_main2.default.map(I.ap, composedf), composedx);
    },
    chain: function chain(fn, composed) {
      return _main2.default.chain(function (inner) {
        return _main2.default.map(joinI, sequenceIS(I.map(fn, inner)));
      }, composed);
    }
  });

  return Composed;
}

/*
// [composed]
chainLatest(fn) {
  // Copy-pasted from .chain, and replaced .chain -> .chainLatest
  // Not sure at all if this is correct or at least works...
  return this.withUncomposed(
    si => si.chainLatest(i => {
      const isi = i[map](x => fn(x).uncompose())
      const sii = isi[sequence](Stream.of)
      const si = sii[map](ii => ii[chain](i => i))
      return si
    })
  )
}

// [composed]
startWith(x) {
  return this.withUncomposed(stream => stream.startWith(Inner[of](x)))
}
*/